
Redmine - Defect #13932

File upload does not work with Safari

2013-05-02 20:57 - Frank Schwarz

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 2.4.6   

Resolution: Fixed Affected version: 2.3.1

Description

Tested with Safari 5.1.7 (Windows), but does also not work with Safari 6 (MacOS) Safari 5.1.9 (MacOS 10.6)

When you attach a file to an issue, a file with content

[object Object]

is created. The actual file is not uploaded.

Related issues:

Related to Redmine - Defect #17151: File upload broken on Chrome 36 Closed

Related to Redmine - Defect #17581: Drag & Drop does not work with Safari 5.1 Closed

Associated revisions

Revision 13184 - 2014-06-25 15:34 - Toshi MARUYAMA

fix file upload does not work with Safari (#13932)

Contributed by Felix Schäfer.

Revision 13187 - 2014-06-25 19:40 - Toshi MARUYAMA

Merged r13184 from trunk to 2.5-stable (#13932)

Fix file upload does not work with Safari.

Contributed by Felix Schäfer.

Revision 13189 - 2014-06-25 19:42 - Toshi MARUYAMA

Merged r13184 from trunk to 2.4-stable (#13932)

Fix file upload does not work with Safari.

Contributed by Felix Schäfer.

Revision 13346 - 2014-08-26 03:17 - Toshi MARUYAMA

fix Drag & Drop does not work with Safari 5.1 (#17581, #13932)

Contributed by fred bregar.

Revision 13348 - 2014-08-26 06:58 - Toshi MARUYAMA

Merged r13346 from trunk to 2.5-stable (#17581, #13932)

fix Drag & Drop does not work with Safari 5.1.

Contributed by fred bregar.

Revision 13349 - 2014-08-26 07:01 - Toshi MARUYAMA

Merged r13346 from trunk to 2.4-stable (#17581, #13932)

fix Drag & Drop does not work with Safari 5.1.
Contributed by fred bregar.

History

#1 - 2013-05-03 23:05 - Filou Centrinov

I can confirm that files won't uploaded via drag & drop on Safari 5.1.7 (Windows). See http://bugs.jquery.com/ticket/12182

#2 - 2013-05-04 04:05 - Mischa The Evil

- Status changed from New to Confirmed

#3 - 2013-05-06 20:24 - Frank Schwarz

I have to correct myself: It does work with Safari 6, but it does not work with Safari 5.1.9 (MacOS 10.6)

#4 - 2013-05-25 00:06 - Jürgen Knödlseder

Confirm. Run in exactly the same bug. Is someone already working on a fix?

#5 - 2013-05-25 13:24 - Toshi MARUYAMA

- Category changed from Files to Attachments

#6 - 2013-08-28 13:03 - Matt Andrews

We've run into this one too Safari 5.1.7 on Windows 7 and Windows 8 - in Redmine version 2.3.3.

#7 - 2013-11-13 23:18 - Dave Martin

Same here with Safari 5.1.10 (6534.59.10) on OS X 10.6.8 with Redmine 2.3.2.

#8 - 2014-05-27 11:11 - Felix Schäfer

A client of Planio encountered the same issue on Mac OS 10.6 and Safari 5.1.9.

The problem is that Safari 5.1 only partially supports the API needed for this: it can pass files around and give the names of the files, but it cannot

send the files as a binary stream directly. There are workarounds to emulate this, but the platform is pretty dated, so we instead chose to fallback to

the normal (non-ajax) upload for Safari 5.1 (or any other browser that doesn't support the FileReader API, which is what is ultimately needed to

achieve this the way it is currently implemented in Redmine):

diff --git a/public/javascripts/attachments.js b/public/javascripts/attachments.js

index ab9f89a..a689c2e 100644

--- a/public/javascripts/attachments.js

+++ b/public/javascripts/attachments.js

@@ -117,7 +117,7 @@ function uploadBlob(blob, uploadUrl, attachmentId, options) {

 function addInputFiles(inputEl) {

   var clearedFileInput = $(inputEl).clone().val('');

-  if (inputEl.files) {

+  if ('FileReader' in window && inputEl.files) {

     // upload files using ajax

     uploadAndAttachFiles(inputEl.files, inputEl);

     $(inputEl).remove();

 The ajax/async upload function still works on modern browsers but is disabled for browsers that don't provide all required APIs for it.

#9 - 2014-05-27 11:23 - Jan from Planio www.plan.io

- Description updated

#10 - 2014-06-24 13:24 - Toshi MARUYAMA

- Related to Defect #17151: File upload broken on Chrome 36 added

#11 - 2014-06-25 15:29 - Toshi MARUYAMA

- Target version set to 2.4.6

#12 - 2014-06-26 05:42 - Toshi MARUYAMA

- Status changed from Confirmed to Closed

- Resolution set to Fixed

Committed in trunk r13184, 2.5-stable r13187, and 2.4-stable r13189, thanks.
http://bugs.jquery.com/ticket/12182
http://plan.io/redmine
https://www.redmine.org/projects/redmine/repository/svn/revisions/13184
https://www.redmine.org/projects/redmine/repository/svn/revisions/13187
https://www.redmine.org/projects/redmine/repository/svn/revisions/13189


#13 - 2014-07-15 01:48 - fred bregar

While this hack

1

 allows the user to click on the "choose" button for <input type=file> and select a file, you still cannot drag a file and upload. Safari 5.1

has no problems uploading File objects via ajax that are drag and dropped (I use it all the time.) The real culprit here is jQuery 1.8.3.

It's jQuery.extend which transforms the File object into a plain Object. $.extend is called from ajaxSetup, which is called from $.ajax on line 7644

re-attaching blob [object File] in beforeSend does the trick

diff --git a/attachments.js.original b/attachments.js

index 43803ba..b6d9eca 100644

--- a/attachments.js.original

+++ b/attachments.js

@@ -99,8 +99,10 @@ function uploadBlob(blob, uploadUrl, attachmentId, options) {

   return $.ajax(uploadUrl, {

     type: 'POST',

     contentType: 'application/octet-stream',

-    beforeSend: function(jqXhr) {

+    beforeSend: function(jqXhr, settings) {

       jqXhr.setRequestHeader('Accept', 'application/js');

+      //attach proper File object 

+      settings.data = blob;

     },

     xhr: function() {

       var xhr = $.ajaxSettings.xhr();

@@ -117,7 +119,7 @@ function uploadBlob(blob, uploadUrl, attachmentId, options) {

 function addInputFiles(inputEl) {

   var clearedFileInput = $(inputEl).clone().val('');

-  if ('FileReader' in window && inputEl.files) {

+  if (inputEl.files) {

     // upload files using ajax

     uploadAndAttachFiles(inputEl.files, inputEl);

     $(inputEl).remove();

 

1

 FileReader API is not needed at all.

#14 - 2014-08-10 15:09 - Toshi MARUYAMA

- Related to Defect #17581: Drag & Drop does not work with Safari 5.1 added
https://github.com/jquery/jquery/blob/869704ba067c9b444bb052140581a426a45baaf5/jquery.js#L291
https://github.com/jquery/jquery/blob/869704ba067c9b444bb052140581a426a45baaf5/jquery.js#L7533
https://github.com/jquery/jquery/blob/869704ba067c9b444bb052140581a426a45baaf5/jquery.js#L7644
http://www.tcpdf.org

